<?php

class TimeRecorderController extends AppController {

	public $layout = "timerecorder";
	public $uses = array('User');
	public $components = array('Auth','Acl');

	public function beforeFilter(){

		$uname = $this->Auth->user('username');
		$act = $this->action;
		$act = $act == 'index' ? 'read' : $act;
		$act = $act == 'updateRecord' ? 'read' : $act;
		$act = $act == 'recordCheck' ? 'read' : $act;
		$act = $act == 'tmList' ? 'create' : $act;
		$act = $act == 'card' ? 'create' : $act;
		$act = $act == 'code39' ? 'create' : $act;

		$this->Session->write('act',$act);

		if ($this->Acl->check($uname, 'timerecorder',$act)){
		} else {
			$this->redirectHttpsAcl();
		}
	}

	public function index(){
		$this->set('title_for_layout', 'TimeRecorder ITS (Free)');
		if(!empty($this->request->query['type'])){
			$this->updateRecord();
			$this->redirectHttps('TimeRecorder');
		}else{
			$code = $this->Session->read('code');
			$this->set('code',$code);
			$this->Session->write('code','');
			$swSe = $this->Session->read('sw');
			$this->set('swSe',$swSe);
			$this->Session->write('sw','');
		    App::import('Vendor', 'config');
		    $this->set('syamei',SYAMEI);
		}
	}

	public function recordCheck(){
		$d_y = date('Y');
		$model = 'Timecard_'.$d_y;
		$d_n = date('n');
		$Record = $this->{$model}->find('all',array('conditions'=>
		array($model.'.month' => $d_n)));//今月のデータ
		$data = $this->User->find('all',array(
			'conditions'=>array('NOT' => array('User.id' => array(1,2)))
		));//現在のユーザーデータ
		$newData[$model] = array();
		foreach( $data as $da ){
			$tiCheck = 0;
			foreach( $Record as $re ){
				if($da['User']['id'] == $re[$model]['user_id']){
					$tiCheck = 1;
					break;
				}
			}
			if($tiCheck == 0){
				$newData[$model][] = array(
					'user_id' => $da['User']['id'],
					'month' => $d_n
				);
			}
		}
		//今月のデータにユーザーがいなければ追加
		if(isset($newData[$model][0])){$this->{$model}->saveAll($newData[$model]);}
	}

	public function updateRecord(){

		$tableCheck = $this->Session->read('timeCardTableCheck');
		$d_y = date('Y');
		$d_n = date('n');
		$tiModel = 'Timecard_'.$d_y;
		$this->uses[] = $tiModel;
		$this->autoRender = false;

		if(empty($tableCheck)){
			App::import('Vendor', 'NewTimeCardTableLibrary');
			tableCheck();
			$this->Session->write('timeCardTableCheck',TRUE);//FALSE
		}
		$this->recordCheck();

		if($this->request->query['type'] == 'attendance'){
			$sw = 'day'.date('j').'a';
			$swm = '出勤';
			$swmno = 'type=attendance&code='.$this->request->query['code'].'&sw=1';
			$field = array($tiModel.'.id',$tiModel.'.'.$sw);
		}elseif($this->request->query['type'] == 'withdrawal'){
			$sw = 'day'.date('j').'w';
			$swm = '退勤';
			$swmno = 'type=withdrawal&code='.$this->request->query['code'].'&sw=1';
			$field = array($tiModel.'.id',$tiModel.'.'.$sw);
		}else{
			$field = array($tiModel.'.id');
			$sw = 'day100w';
		}

		$data = $this->{$tiModel}->find('first',
		array(
			    'conditions'=> array($tiModel.'.month' => $d_n , $tiModel.'.user_id' => $this->request->query['code']),//conditions　検索
			    'fields' => $field//fields　取得するフィールド
		    )
		);
		$user = $this->User->find('first',
	    array(
		    'conditions'=> array('User.id' => $this->request->query['code']),
		    'fields' => array('User.name','mail')
		    )
		);

		if(!empty($data[$tiModel][$sw]) && empty($this->request->query['sw'])){
			$this->Session->write('code', $user['User']['name'].'さんの「'.$swm.'」は'.
			date("H：i：s",$data[$tiModel][$sw]).'で記録されてますが上書きしますか？');
			$this->Session->write('sw', $swmno);
		}elseif(empty($data)){
			$this->Session->write('code','該当者がいません');
		}elseif($this->request->query['type'] == 'attendance'){
			$time = time();
			$this->request->data[$tiModel]['id'] = $data[$tiModel]['id'];
			$this->request->data[$tiModel]['day'.date('j').'a'] =  $time;
			$this->{$tiModel}->save($this->data);

			$this->Session->write('code',$user['User']['name'].'<br />出勤　'.date("Y年n月j日H時i分s秒",$time).'<br />で記録しました');

		}elseif($this->request->query['type'] == 'withdrawal'){
			$time = time();
			$this->request->data[$tiModel]['id'] = $data[$tiModel]['id'];
			$this->request->data[$tiModel]['day'.date('j').'w'] =  $time;
			$this->{$tiModel}->save($this->data);
			$this->Session->write('code',$user['User']['name'].'<br />退勤　'.date("Y年n月j日H時i分s秒",$time).'<br />で記録しました');
		}elseif(empty($user['User']['mail'])){
			$this->Session->write('code','PCメールアドレスが<br />登録されてません');
		}elseif($this->request->query['type'] == 'withdrawal2'){

			$data2 = $this->{$tiModel}->find('first',array('conditions'=>
			array($tiModel.'.id' => $data[$tiModel]['id'])));

			$d_y2 = date('Y', strtotime(date('Y-m-1').' -1 month'));
			$d_n2 = date('m', strtotime(date('Y-m-1').' -1 month'));
			$tiModel2 = 'Timecard_'.$d_y2;
			if($tiModel != $tiModel2){$this->uses[] = $tiModel2;}
			$data3 = $this->{$tiModel2}->find('first',array('conditions'=>
			array($tiModel2.'.month' => $d_n2 , $tiModel2.'.user_id' => $this->request->query['code'])));

			$body_html = '<table border="0" cellspacing="0" cellpadding="5"><tr><td colspan="3">
			タイムカード　（'.$user['User']['name'].'）<br />
			'.$d_y2.'年'.$d_n2.'月度<br />
			'.date("Y年n月j日").'現在
			</td></tr>
			<tr><td>日付</td><td>出勤</td><td>退社</td></tr>
			';
			$nissuu = date('t', strtotime(date('Y-m-1').' -1 month'));;
			$data_yn = "$d_y2/$d_n2/";
			$weekday = array( "日", "月", "火", "水", "木", "金", "土" );
			$weekNo = date("w", strtotime("$d_y2-$d_n2-1"));
			for($a = 1; $a <= $nissuu; $a++) {
				$day = '<td>'.$data_yn.sprintf("%02d", $a).' （'.$weekday[$weekNo].'）</td>';
				if($weekNo == 6){$weekNo = 0;}else{$weekNo++;}
				if(!empty($data3[$tiModel2]['day'.$a.'a'])){
					$day .= '<td>'.date("H：i：s",$data3[$tiModel2]['day'.$a.'a']).'</td>';
				}else{
					$day .= '<td>&nbsp;</td>';
				}
				if(!empty($data3[$tiModel2]['day'.$a.'w'])){
					$day .= '<td>'.date("H：i：s",$data3[$tiModel2]['day'.$a.'w']).'</td>';
				}else{
					$day .= '<td>&nbsp;</td>';
				}
				$body_html .= '<tr>'.$day.'</tr>'. "\r\n";
			}
			$body_html .= '</table><br /><br />'. "\r\n";

			$body_html .= '<table border="0" cellspacing="0" cellpadding="5"><tr><td colspan="3">
			タイムカード　（'.$user['User']['name'].'）<br />
			'.$d_y.'年'.$data2[$tiModel]['month'].'月度<br />
			'.date("Y年n月j日").'現在
			</td></tr>
			<tr><td>日付</td><td>出勤</td><td>退社</td></tr>
			';
			$nissuu = date("t");
			$data_yn = date("Y/n/");
			$data_ynw = date("Y-n-");
			for($a = 1; $a <= $nissuu; $a++) {
				$day = '<td>'.$data_yn.sprintf("%02d", $a).' （'.$weekday[$weekNo].'）</td>';
				if($weekNo == 6){$weekNo = 0;}else{$weekNo++;}
				if(!empty($data2[$tiModel]['day'.$a.'a'])){
					$day .= '<td>'.date("H：i：s",$data2[$tiModel]['day'.$a.'a']).'</td>';
				}else{
					$day .= '<td>&nbsp;</td>';
				}
				if(!empty($data2[$tiModel]['day'.$a.'w'])){
					$day .= '<td>'.date("H：i：s",$data2[$tiModel]['day'.$a.'w']).'</td>';
				}else{
					$day .= '<td>&nbsp;</td>';
				}
				$body_html .= '<tr>'.$day.'</tr>'. "\r\n";
			}
			$body_html .= '</table>'. "\r\n";
			//-------------------------------------------------------------------メール送信
			App::import('Vendor', 'config');
			$to = $user['User']['mail'];// 宛先
			$from = APMEIL;// 送信元
			$fromName = 'タイムレコーダー　ITS';// 送信者
			$subject = mb_encode_mimeheader('タイムレコーダー詳細',"ISO-2022-JP");// タイトル
			$message = '
			<html>
			<head>
			<title>タイムレコーダー詳細</title>
			<style type="text/css">
			table {
				border-top-width: 1px;
				border-left-width: 1px;
				border-top-style: solid;
				border-left-style: solid;
				border-top-color: #666;
				border-left-color: #666;
			}

			td {
				border-right-width: 1px;
				border-bottom-width: 1px;
				border-right-style: solid;
				border-bottom-style: solid;
				border-right-color: #666;
				border-bottom-color: #666;
			}
			</style>
			</head>
			<body>
			'.$body_html.'
			</body>
			</html>
			';
			$headers  = 'MIME-Version: 1.0' . "\r\n";
			$headers .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
			$headers .= 'From: '.mb_encode_mimeheader($fromName,"ISO-2022-JP").' <'.$from.'>' . "\r\n";
			mail($to, $subject, $message, $headers);// 送信する
			//-------------------------------------------------------------------
			$this->Session->write('code',$user['User']['name'].'さんに<br />詳細をメールしました');
		}
	}
	public function tmList(){
		$this->layout = "business";
	  	$this->set('title_for_layout', '出退勤訂正・印刷・データコピー　TimeRecorder ITS (Free)');
	  	if(!empty($this->request->data['y']['year'])){
	  		$d_y = $this->request->data['y']['year'];
	  	}else{
	  		$d_y = date('Y');
	  		$this->request->data['y']['year'] = $d_y;
	  	}
	  	if(!empty($this->request->data['n']['month'])){
	  		$d_n = $this->request->data['n']['month'];
	  	}else{
	  		$d_n = date('n');
	  		$this->request->data['n']['month'] = $d_n;
	  	}
		//------------------------------------------出退勤時間修正削除
		$tiModel = 'Timecard_'.$d_y;
		$this->uses[] = $tiModel;
		if(!empty($this->request->data['deletet']) &&//-----削除
		   !empty($this->request->data[$tiModel]['id']) &&
		   !empty($this->request->data['d']) &&
		   !empty($this->request->data['aw'])
		){
			$this->request->data[$tiModel]['day'.$this->request->data['d'].$this->request->data['aw']] = '';
			$this->request->data[$tiModel]['data_day'.$this->request->data['d'].$this->request->data['aw']] = '入力';
			$this->$tiModel->save($this->data);
		}elseif(!empty($this->request->data[$tiModel]['id']) &&//-----修正
		        !empty($this->request->data['d']) &&
		        !empty($this->request->data['aw']) &&
		        !empty($this->request->data['h']) &&
		        !empty($this->request->data['i'])
		){
			$time = strtotime($d_y.'-'.sprintf("%02s",$d_n).'-'.$this->request->data['d'].' '.
				$this->request->data['h'].':'.$this->request->data['i'].':00');
			$this->request->data[$tiModel]['day'.$this->request->data['d'].$this->request->data['aw']] = $time;
			$this->request->data[$tiModel]['data_day'.$this->request->data['d'].$this->request->data['aw']] = '入力';
			$this->$tiModel->save($this->data);
		}
		//------------------------------------------項目取得
		$data = $this->$tiModel->find('all',array(
			'conditions'=>array('month' => $d_n),
			'fields' => array('id','user_id')
		));
		$selectName = array();
		if(!empty($data[0][$tiModel]['user_id'])){
			$user = $this->User->find('all',array('fields' => array('User.id','User.name')));
			$userAr = array();
			foreach( $user as $va ){
				$userAr[$va['User']['id']] = $va['User']['name'];
			}
			foreach( $data as $va ){
				$selectName[$va[$tiModel]['id']] = $userAr[$va[$tiModel]['user_id']];
			}
		}
		//------------------------------------------出退勤時間取得
		if(!empty($this->request->data[$tiModel]['id'])){
			$data2 = $this->$tiModel->find('first',array('conditions'=>
				array('id' => $this->request->data[$tiModel]['id'])));
		}else{
			$data2 = array();
		}
	  	$this->set('d_y',$d_y);
	  	$this->set('d_n',$d_n);
	  	$this->set('tiModel',$tiModel);
	  	$this->set('selectName',$selectName);
		$this->set('data2',$data2);
	}
	public function card(){
		$message = '';
		$this->set('message',$message);
	  	$this->set('title_for_layout', 'タイムカード印刷 　TimeRecorder ITS (Free)');
	  	$this->layout = "business";
	    $data = $this->User->find('all',
		    array(
			    'conditions'=>array('NOT' => array('User.id' => array(1,2))),
			    'fields' => array('User.id','User.name'),
			    'order' => array('User.id')
		    )
		);
	    $this->set('data',$data);
	    App::import('Vendor', 'config');
	    $this->set('syamei',SYAMEI);
	}
	public function code39(){
		$barstr = $_GET["bcdstr"];
		$ny = 50;               //高さ(pixel)
		$wunit = 2;             //基準幅(pixel)
		$ar_bcd = array("0"=>"101001101101", "1"=>"110100101011"
		  ,"2"=>"101100101011", "3"=>"110110010101"
		  ,"4"=>"101001101011", "5"=>"110100110101"
		  ,"6"=>"101100110101", "7"=>"101001011011"
		  ,"8"=>"110100101101", "9"=>"101100101101"
		  ," "=>"100110101101", "$"=>"100100100101"
		  ,"%"=>"101001001001", "*"=>"100101101101"
		  ,"+"=>"100101001001", "-"=>"100101011011"
		  ,"."=>"110010101101", "/"=>"100100101001"
		  ,"A"=>"110101001011", "B"=>"101101001011"
		  ,"C"=>"110110100101", "D"=>"101011001011"
		  ,"E"=>"110101100101", "F"=>"101101100101"
		  ,"G"=>"101010011011", "H"=>"110101001101"
		  ,"I"=>"101101001101", "J"=>"101011001101"
		  ,"K"=>"110101010011", "L"=>"101101010011"
		  ,"M"=>"110110101001", "N"=>"101011010011"
		  ,"O"=>"110101101001", "P"=>"101101101001"
		  ,"Q"=>"101010110011", "R"=>"110101011001"
		  ,"S"=>"101101011001", "T"=>"101011011001"
		  ,"U"=>"110010101011", "V"=>"100110101011"
		  ,"W"=>"110011010101", "X"=>"100101101011"
		  ,"Y"=>"110010110101", "Z"=>"100110110101"
		  );
		$nx = 12 * $wunit * (strlen($barstr)+1);
		$bc = ImagecreateTruecolor($nx, $ny);   //イメージを作成
		$background = imagecolorallocate($bc, 255,255,255);     //背景色(白)
		$color = imagecolorallocate($bc, 0,0,0);                //コード色(黒)
		imagefill($bc, 0, 0, $background);                      //背景設定
		$xpos = 0;              //左からの位置
		for ($i = 0; $i < strlen($barstr); $i++){
		  //- 文字単位の処理 ----
		  $chrptn = $ar_bcd[substr($barstr, $i, 1)];   //一文字のパターン
		  for ($j = 0; $j < 12; $j++){
		    //一文字分のバーコード ----
		    if (substr($chrptn,$j,1) == "1"){
		      for($w = 0; $w < $wunit; $w++){
		        imageline($bc, $xpos+$w, 0, $xpos+$w, $ny-1, $color);
		      }
		    }
		    $xpos += $wunit;
		  }
		  $xpos += $wunit;
		}
		//- イメージ出力 ----
		header("Content-type: image/png");
		imagepng($bc);
		imagedestroy($bc);      //リソース解放
		$this->autoRender = false;
	}
}

